#!/usr/bin/perl 
use strict;
#use lib qw( /var/www/vhosts/alpha-bound.de/cgi-bin) 
use lib qw(/var/www/vhosts/alpha-bound.de/httpdocs/aplpl);
use vars qw($ots $dd $globalEnv $WWW);
use subs qw(&parserInit &printEnv);

use CGI qw(:standard escape unescape);
use CGI::Carp qw(fatalsToBrowser);
use Aplpl::ARSP;
use Aplpl::EXP;
use Aplpl::ENV;
use Aplpl::EVAL;
use Aplpl::NAME;
use Aplpl::PAIR;
use Aplpl::VALUE;

$WWW = 1;

my $q = new CGI;

my $ins        = $q->param('CODE');
my $action     = $q->param('Action');
my $host       = $q->remote_host();
my $addr       = $q->remote_addr();
my $user       = $q->remote_user();
my $ident      = $q->remote_ident();
my $referer    = $q->referer();
my $agent      = $q->user_agent();
my $demo1      = "Bank Account";
my $demo2      = "Animal Shelter Demo";
my $demo3      = "Library Demo";

if (!$ins)     { $ins = ""; }
if (!$host)    { $host = " "; }
if (!$addr)    { $addr = " "; }
if (!$user)    { $user = " "; }
if (!$ident)   { $ident = " "; }
if (!$referer) { $referer = " "; }
if (!$agent)   { $agent = " "; }

$dd = gmtime();
open (LOG, ">>aplpl.log");
print (LOG "Time:          " . "$dd" . "\n");
print (LOG "Host:          " . "$host" . "\n");
print (LOG "Address:       " . "$addr" . "\n");
print (LOG "User:          " . "$user" . "\n");
print (LOG "Ident:         " . "$ident" . "\n");
print (LOG "Referer:       " . "$referer" . "\n");
print (LOG "User-Agent:    " . "$agent" . "\n");
close (LOG);  

# HTML starten
#   
print $q->header();

$ots           = "";


sub main {
   my $parser = newARSP();
   eval {
      if ($action eq $demo1) {
         $ins = "(load \"http://www.aplusplus.net/app/init.app\")\n" .
                "(load \"http://www.aplusplus.net/app/bank.app\")";
i
      }
      elsif ($action eq $demo2) {
         $ins = "(load \"http://www.aplusplus.net/app/init.app\")\n" .
                "(load \"http://www.aplusplus.net/app/shelter.app\")\n" .
                "(animal-shelter)";
      }
      elsif ($action eq $demo3) {
         $ins = "(load \"http://www.aplusplus.net/app/init.app\")\n" .
                "(load \"http://www.aplusplus.net/app/library.app\")\n" .
                "(library)";
      }
      elsif ($action eq "Evaluate") {
         if ($ins ne "") {
            my $exp = "";
            $parser->('init', $ins);
            $exp = $parser->('readexp');
            while ($exp != $eof) {
               prValue(evalThunk(leval($exp, $globalEnv, $trueSym)));
               $exp = $parser->('readexp');
            }
         }
         else {
            $ots = $ots . sprintf("%s", "<void>\n");
         }
      }
      else {
      }
   };
   if ($@) {
      $ots = $ots . sprintf("%s","error: $@ \n");
   }
}

$globalEnv = initGlobalEnv();

main();

print <<ENDE;
<html>
<head>
   <title>A++ Interpreter Demo</title>
</head>
<body bgcolor=#fffce1>
<h1>A++ Interpreter Demo</h1>
<h4>A++ Code to be evaluated:</h4>
<form action="https://www.alpha-bound.de/cgi-bin/appidemo.cgi" method=post>
<table>
  <tbody>
    <tr>
      <td>
      <textarea name='CODE' rows=15 cols=70 readonly>
ENDE

print "$ins",
      "</textarea></td>",
      "<td  align=\"left\">",
      "<INPUT type=\"submit\" name=\"Action\" value=\"Bank Account\"><br><br>",
      "<INPUT type=\"submit\" name=\"Action\" value=\"Animal Shelter Demo\"><br><br>",
      "<INPUT type=\"submit\" name=\"Action\" value=\"Library Demo\"><br>",
      "</td></tr></tbody></table><br>",
      "<INPUT type=\"submit\" name=\"Action\" value=\"Evaluate\">\n",
      "<h4>Result of evaluation</h4>\n",
      "<textarea name=\"OUTPUT\" rows=10 cols=70>\n",
      "$ots";

print <<END;
</textarea> 
</form>
</body> 
</html> 
END
